/* 
        SvgaPalette.h

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	shimarincode򸵤Yamahata񤤤ʪǤ
*/
#include <stdio.h>
#include <iostream.h>
#include <assert.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "MaslConst.h"
#include "MaslInputStream.h"
#include "Masl.h"

#ifndef svga_palette_h
#define svga_palette_h

struct PALETTE
{
  unsigned char r,g,b;
};

class SvgaPalette      
{
  //variables
private:
  char fileName[17];//file name
  PALETTE palette[NUMBER_OF_COLORS];//palette
  static PALETTE paletteOfNow[NUMBER_OF_COLORS];
  //ꤵƤpalette(â뤵ޤǤϴޤޤʤ)
  static void setXColor (PALETTE& xcolor,
			 const int r,const int g,const int b,
			 const int contrast=100);
  
  //methods
public:
  SvgaPalette (MaslInputStream& maslIs);
  ~SvgaPalette ();
  void setPalette (const int contrast=100);
  static void setPalette (const int paletteNumber,
			  const int r,const int g,const int b,
			  const int contrast=100);
  static void setTone (const int contrast);
  static void mix (const int paletteNumber1,const int paletteNumber2,
		   const int ratio,const int contrast=100);
  //paletteNumber11֤paletteNumber2֤
  //ѥåȤ򤽤줾ratio(100-ratio)󺮤ѥåȤ
  //contrastϥȡ͡

  
};
#endif //svga_palette_h
