/* 
        maslplay.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarincode򸵤YamahataľʪǤ
	ޤcommentˤKunimaslֺ(maslt120.lzh)ѤƤ
	ʬͭޤ

*/
#include <vgakeyboard.h>

#include "Masl.h"
#include "MaslAudio.h"
#include "audio.h"
#include "SvgaPalette.h"
#include "Cell.h"
#include "maslCommand.h"
#include "getScanCode.h"

/*
*masl˹Ԥʤѿν
*audio deviceopenԤʤ
*/
void Masl::preparePlay ()
{
  ///////////////////////////////////////////////Ƽѿν
  pt=scenario->getBeginPoint ();

  timer.reset ();
  timer.setCount (scenario->getTimerCounter ());
  timeCntForWait=0;
  isWaiting=False;
  is200LineMode=False;
  isGraphicOn=True;

  aheadlyExtractedCellNumber=-1;
  delete cellAhead;
  cellAhead=NULL;

  isAudioWriting=False;
  isAudioWaiting=False;

  numberOfCall=0;
  numberOfLoop=0;
  nShowPage=0;
  nDrawPage=0;
  viewPort.left=0;
  viewPort.top=0;
  viewPort.right=SIZE_X-1;
  viewPort.bottom=SIZE_Y-1;
  if (xmaslOption.isFullsize)//full mode
    viewPort.bottom=VRAM_SIZE_Y-1;
  nVramOrg=0;
  gdcLoop=PLANE_LENGTH;
  
  errorLevel=NULL;
  normalExit=0;//νͤˤϰ̣ͭޤ
  escapeExit=-1;//νͤˤϰ̣ͭޤ
  
  memset (intVar,0,sizeof (intVar));
  //ͤǤѿνͤɤʤΤǤ(꤫)dataˤ
  //ͤ0ǤԤƤʪͭΤǰ0clearƤޤ


  //audio device open
  if (numberOfPcm>0)
    {
      if (!(MaslAudio::openAudioDevice ()))
	{
	  cerr << "masl:can not open audio device." << endl;
	  cerr << "continue playing data with no audio." << endl;
	  MaslAudio::disableAudio ();
	}
      //ϤäɤΤʤ̵ɤ⡢
      //sample rateꤷƤʤΤͭ褦
      if (!(MaslAudio::initializeAudioDevice (DEFAULT_SAMPLE_RATE)))
	{
	  cerr << "masl:can not initialize PCM rate." << endl;
	  cerr << "may play audio with wrong sampling rate." << endl;
	}
    }
  else
    {//PCM data̵Τaudio̵ˤƤ
      MaslAudio::disableAudio ();
    }
  MaslAudio::prepareMaslAudio (&isAudioWriting,&isAudioWaiting);

  ///////////////////////////////////////////////keyboardν
  if (keyboard_init ()==-1)
    {
      cout << "can not open the keyboard." << endl;
      setSvgaMode (TEXT);
      gl_freecontext (physicalScreen);
      exit (-1);
    }
  keyboard_translatekeys (TRANSLATE_CURSORKEYS|
			  TRANSLATE_DIAGONAL|
			  TRANSLATE_KEYPADENTER);
  getScanCode_init ();
}

/*
*audio deviceclose
*
*/
void Masl::afterPlay ()
{
  //////////////////////////////keyboad̾ξ֤᤹
  keyboard_close ();
  
  //sound deviceclose
  MaslAudio::offAudioTimer ();
  if (MaslAudio::isAudioEnabled ())
    MaslAudio::closeAudioDevice ();

  if (xmaslOption.isPause)//λkeyԤ򤹤
    {
#if 0
      XEvent tmpEvent;
      for (;;)
	{
	  XNextEvent (display,&tmpEvent);
	  if (tmpEvent.type==KeyPress)//key줿齪λ
	    break;
	  updateWindow ();//ʳʤ
	}
#endif
    }
}


Bool Masl::play ()
{
  if (timer.isNotStarted ())
    timer.start ();
  
  for (;;)
    {
    CONTINUE:
      ////////////////////////////////////////////////////////Xevent
      keyboard_update ();
      if (keyboard_keypressed (SCANCODE_ESCAPE)==KEY_PRESSED)
	return False;

#if 0
      //while (XCheckMaskEvent (display,maslEventMask,&event))
      if (XCheckMaskEvent (display,maslEventMask,&event))
	{
	  switch (event.type)
	    {
	    case KeyPress:
	      switch(XKeycodeToKeysym (display,event.xkey.keycode,0))
		{
		case XK_Escape://Escape keyƤкλ
		  if (errorLevel!=NULL)
		    {//error levelꤵƤ
		      //error levelescapeǽλꡣ
		      errorLevel=&escapeExit;
		    }
		  MaslAudio::resetAudio ();//PCMߤ롣
		  return False;
		  break;//ǰΰ
		default://do nothing
		  break;
		}
	      break;
	    case Expose://̤κ
	      updateWindow ();
	      break;
	    case ButtonPress:
	      switch (event.xbutton.button)
		{
		case 1:
		  {
		    CopyImage2Root copyImage2Root (display,screen,window,
						   planeMask[0]|planeMask[1]|
						   planeMask[2]|planeMask[3]);
		    copyImage2Root.copyImage2Root ();
		  }
		  break;
		case 2:
		  XIconifyWindow (display,window,screen);
		  break;
		default:
		  break;//⤷ʤ
		}
	      break;
	    default://ʤΤʤǰΰ
	      //⤷ʤ
	      break;
	    }
	}
#endif

      ///////////////////////////////////////////////////////PCMԤ
      if (isAudioWaiting!=0)
	{
#ifdef MIX_AUDIO
	  if ((isAudioWriting & isAudioWaiting)!=0)
#else
	  if (isAudioWriting!=0)
#endif
	    {
	      //continue;
	      return True;
	    }
#ifdef MIX_AUDIO
	  //do nothing
#else
	  MaslAudio::sync ();
#endif
	  isAudioWaiting=0;
	}
      

      ///////////////////////////////////////////////timerϢ(timer countԤ)

      if (isWaiting)
	{//timerԤ
	  if (timer.getNowCount ()<(long)timeCntForWait*100)
	    {//timerԤʤΤǡ롣
	      //continue;
	      return True;
	    }

	  //timerԤλ
	  timeCntForWait=0;
	  isWaiting=False;
	  if (*pt=='c')//tP1cä
	    {
	      pt++;
	      timer.clearTimer ();
	    }
	}
 
      //////////////////////////////////////////scenarioϤλϤޤ
      if (searchNextCommand ()==False)
	return False;

      ///////////////////////////////////////////  command&¹
      for (int i=0;i<numberOfCommand;i++)
	{
	  if (strncmp (pt,commandTable[i].command,
		       strlen (commandTable[i].command))==0)//commandβ
	    {
	      //cout << commandTable[i].command << endl;
	      commandTable[i].executeCommand (*this);//command¹
	      //goto CONTINUE;
	      return True;
	    }
	}

      if (*pt=='\\')//\:scenarioνλ
	{//'\n'
	 //εǽ  ̤nΰŤˤƥʥꥪλ
	 //   '\100' - ̤򤽤Τޤޤˤƽλ
	 //P1άϲ̤õƽλޤ
	  pt++;
	  int contrast=0;
	  if (isdigit (*pt))
	    contrast=getValue ();
	  SvgaPalette::setTone (contrast);
	  return False;
	}     
      
      ////////////////error
      if (*pt=='@'||*pt=='.'||*pt=='\'')
	{
	  pt++;
	  continue;
	}

      if (isdigit (*pt))
	{
	  searchnum ();
	  continue;
	}
      
      while (*pt!=' ' && *pt!='\t' && *pt!='\r' && *pt!='\n' 
	     && *pt!=';' && scenario->isNotEnd (pt))
	{
	  pt++;
	}

      if (scenario->isEnd (pt))
	{
	  return False;
	}
    }//for (;;)
}
