/* 
        maslCommand.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include "Masl.h"
#ifndef masl_command_h
#define masl_command_h

const Masl::MASL_COMMAND Masl::commandTable[]=
{/////////////////////////////////////ʲν֤Ǥ롣
  //////////ְ֤㤨ȡư롣
  ////////////////////////////////////////timer Ϣ
  {"tc",Masl::cmdTc},
  {"tone",Masl::cmdTone},
  {"t",Masl::cmdT},
  ///////////////////////////////////////Ϣ
  //{"[=",},
  //{"[!",},
  //{"[<=",},
  //{"[<",},
  //{"[>=",},
  //{"[",},
  {"[",Masl::cmdLeftBracket},

  //{"]=",},
  //{"]!",},
  //{"]<=",},
  //{"]<",},
  //{"]>=",},
  //{"]>",},
  //{"]",Masl::cmdRightBracket}
  {"]",Masl::cmdRightBracket},

  //{"{=",},
  //{"{!",},
  //{"{<=",},
  //{"{<",},
  //{"{>=",},
  //{"{",Masl::cmdLeftBrace},
  {"{",Masl::cmdLeftBrace},
  {"}",Masl::cmdRightBrace},
  //{"else",},
  {"#",Masl::cmdLabel},

  //{"j=",Masl::cmd_jump_eq},
  //{"j!",},
  //{"j>=",},
  //{"j>",},
  //{"j<=",},
  //{"j<",},

  {"j",Masl::cmdJump},
  //{"\\",//Ϥɤ񤯤Τ,}

  //{"call=",},
  //{"call!",},
  //{"call<=",},
  //{"call<",},
  //{"call>=",},
  //{"call>",},

  {"call",Masl::cmdCall},
  {"ret",Masl::cmdRet},
  //////////////////////////////////////////math
  {"=@",Masl::cmdLet},
  {"+@",Masl::cmdPlus},
  {"-@",Masl::cmdMinus},
  {"*@",Masl::cmdTimes},
  {"/@",Masl::cmdDivide},
  {"%@",Masl::cmdModulo},
  {"&@",Masl::cmdAnd},
  {"|@",Masl::cmdOr},
  {"^@",Masl::cmdXor},

  ////////////////////////////////////////graphi & pcm & etc...
  {"box",Masl::cmdBox},
  {"cls",Masl::cmdCls},
  {"count",Masl::cmdCount},
  {"d",Masl::cmdD},
  {"err",Masl::cmdError},
  {"goff",Masl::cmdGoff},
  {"gon",Masl::cmdGon},

  //{"line4",Masl::cmd_line4},
  //{"line2",Masl::cmd_line2},

  {"line",Masl::cmdLine},
  {"mask",Masl::cmdMask},
  {"move",Masl::cmdMove},
  {"o2u",Masl::cmdO2u},
  {"out",Masl::cmdOut},
  {"pal_",Masl::cmdPalNum},
  {"pal",Masl::cmdPal},
  {"pcm",Masl::cmdPcm},
  {"pd",Masl::cmdPd},
  {"pmix",Masl::cmdPmix},
  {"pst",Masl::cmdPst},
  {"pwt",Masl::cmdPwt},
  {"pw",Masl::cmdPw},
  {"rate",Masl::cmdRate},
  {"roll",Masl::cmdRoll},
  {"u2o",Masl::cmdU2o},
  {";",Masl::cmdComment},
};
  
const int Masl::numberOfCommand=sizeof (Masl::commandTable)/sizeof (Masl::MASL_COMMAND);
#endif //masl_command_h
